package ogss;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.lang.StringBuffer;


public class AnaphoraResolution {
	//gobj-hAgloc-hAggoal-hƂΉ
	static String[] frame = {"obj","loc","goal"};
	static String[] anaphora = {"","",""};
	static String[] pro = {"ZeroPro","ModPro"};
	String line="";
	static double adds1=1.0;//bṽXRAt
	static double adds2=1.0;//bṽXRAt
	static double adds3=0.6;//qṽXRAt
	AnaphoraResolution(String juli) {
		ParseFrame pf = new ParseFrame();
		this.line=pf.parsing((String)juli);
		try{
			FileWriter filewriter = new FileWriter(new File("DL2.txt"),true);
			filewriter.write(this.line);
			filewriter.close();

		}catch(IOException e){
			System.out.println(e);
		}
		if(AppFrame.option_anaphora() == 2){
			if(AnaphoraResolution.searchAnarhora(AnaphoraResolution.zeroDitect(this.line))){
				this.line=coreAR(this.line);
			}
		}
	}

	//K{AK{łZeroProAModProɏƉu
	public static String zeroDitect(String line){
		//ZeroProModProɂ₻}֐
		String text = line;
		int index = 0;
		int N = anaphora.length;
		//System.err.println(text);
		ArrayList<String> sem = new ArrayList<String>();
		for(int i = 0; i < N; i++){
			sem = ParseVoca.tree(frame[i],sem);
			text= text.replaceAll("ZeroPro\\("+getSemantic(text,0)+"\\):"+frame[i],anaphora[i]+"\\("+getSemantic(text,0)+"\\):"+frame[i]);
		}
		if(line.indexOf("ModPro") >= 0){
			index=line.indexOf("ModPro");
		}
		for(int i = 0; i < N; i++){
			sem = ParseVoca.tree(frame[i],sem);
			text=text.replaceAll("ModPro\\("+getSemantic(text,index)+"\\):"+frame[i],anaphora[i]+"\\("+getSemantic(text,index)+"\\):"+frame[i]);
		}
		return text;
	}

	//₻Ȃǂlineɂ邩̔
	public static boolean searchAnarhora(String line) {
		for(int i = 0; i != anaphora.length; i++){
			if(line.indexOf(anaphora[i]) >= 0){
				return true;
			}
		}
		return false;
	}

	//ZeroProModProȂǂlineɂ邩̔
	public static boolean indispensa(String line) {
		for(int i = 0; i != pro.length; i++){
			if(line.indexOf(pro[i])>=0){
				return true;
			}
		}
		return false;
	}

	//₻ȂǂlineɂʒuԂ
	public static int returnPoint(String line,int index) {
		int indexes=10000;
		for(int i = 0; i != anaphora.length; i++){
			if(line.indexOf(anaphora[i],index)>=index){
				if(indexes>line.indexOf(anaphora[i],index)){
					indexes=line.indexOf(anaphora[i],index);
				}
			}
		}
		if(indexes==10000)
			return -1;
		return indexes;
	}

	//₻ȂǂlineɂƉsemanticԂ
	public static String getSemantic(String line,int index) {
		if(line.equals("")){
			return "";
		}
		String sentence="";
		StringBuffer sent = new StringBuffer(line);
		sent = sent.delete(0,index);
		String key = "\\(([a-zA-Z_]+)\\):";

		Pattern pat = Pattern.compile(key);
		Matcher mat = pat.matcher(sent);

		while(mat.find(1)){
			sentence = mat.group(1);
			return sentence;
		}
		return "";
	}

	//₻ȂǂlineɂƉ̊iԂ
	public static String getCase(String line,int index) {
		if(line.equals(""))
			return "";
		String sentence="";
		StringBuffer sent = new StringBuffer(line);
		sent = sent.delete(0,index);
		String key = ":([a-zA-Z_]+)";

		Pattern pat = Pattern.compile(key);
		Matcher mat = pat.matcher(sent);

		while(mat.find(1)){
			sentence = mat.group(1);
			return sentence;
		}
		return "";
	}

	//vZ֐
	public static double calculation(double conf1 ,double conf2,double dist,int sc){
		double a = 1.5;
		double b = 0.5;
		double df = 1 / Math.pow(dist,2.0);

		df = df / Math.pow(10, (double)sc);
		return (a*conf1+b*conf2)*df;
	}

	//ƉłĂƉ
	public static String coreAR(String parseLine) {
		String text = "";
		String line = "";
		try {
			String keyword = "";
			ArrayList<String> Confidence = new ArrayList<String>();		//L[[hƂ̐Mx
			ArrayList<String> Conf = new ArrayList<String>();			//L[[hƂ̐Mx
			if(AppFrame.option_recogType() == 3){
				BufferedReader br1 = new BufferedReader(new InputStreamReader(new FileInputStream("DL1.txt")));
				while((text = br1.readLine()) != null){
					Conf.add(text);
				}
				if(Conf.size() > 300){
					Conf.remove(0);
				}
				br1.close();
			}

			BufferedReader br2 = new BufferedReader(new InputStreamReader(new FileInputStream("DL2.txt")));
			while((text = br2.readLine()) != null){
				Confidence.add(text);
			}
			br2.close();
			if(Confidence.size()>300){
				Confidence.remove(0);
			}
			//siftĂŃXgăXRAĂČvZ
			ArrayList<String> list = new ArrayList<String>();
			ArrayList<String> list2 = new ArrayList<String>();
			int size=Confidence.size()-1;
			int midsize=Conf.size();

			text = Confidence.get(size).toString();

			for(int i = 0; returnPoint(zeroDitect(parseLine),i) >= 0; i = returnPoint(zeroDitect(text),i)+1){
				int count=0;
				double max=-1.0;
				String Case="";
				ArrayList<String> voca = new ArrayList<String>();
				ArrayList<String> voca2 = new ArrayList<String>();
				String sem = getCase(zeroDitect(Confidence.get(size).toString()), returnPoint(zeroDitect(Confidence.get(size).toString()),i));
				String sem2 = getSemantic(parseLine, returnPoint(zeroDitect(parseLine),i));
				if(sem.equals("goal")){
					sem="loc";
				}
		 		voca=ParseVoca.tree(sem,voca);
		 		voca.add(sem);
		 		voca2=ParseVoca.tree(sem2,voca2);
		 		voca2.add(sem2);

				for(int j =0;j<10 &&(j <= size-1);j++){
					if(Confidence.get(j).equals("/")){
						count++;
					}
					list = KeyExt.sift(del(Confidence.get(size-j-1)));
					if(AppFrame.option_recogType()==3){
						list2 = KeyExt.sift(Conf.get(midsize-j-1));
					}
					//ConfidenceɂPꂪConfɂȂ肵ĂsiftscoreŒo
					for(int k=0;k<list.size();k++){
						double sc=0.0;
						for(int l = 0; l < list2.size(); l++){
							if(list.get(k).equals(list2.get(l))){
								sc = getScore(list2.get(l));
							}
						}
						if(!searchAnarhora((String)list.get(k)) && !indispensa((String)list.get(k))){
							double addsc =0.0;
							if(!ParseConfig.getUseSemFeat()){
								addsc =1.0;
							}
							if(ParseConfig.getUseSemFeat()){
								if(repetition(getSemantic((String)list.get(k),0),voca2)){
									addsc = adds3;
								}
								if(getSemantic((String)list.get(k),0).equals(sem2)){
									addsc = adds1;
								}
								//System.err.println("b:"+list.get(k));
								if(getSemantic((String)list.get(k),0).equals("unknown")){
									addsc = 0.2;
								}
							}
							if(getCase((String)list.get(k),0).equals("goal")){
								Case="loc";
							}
							else{
								Case=getCase((String)list.get(k),0);
							}
								if(repetition(Case,voca)){
								if(calculation(getScore(list.get(k))*addsc,sc*addsc,(double)(j+1),count)>max){
									max=calculation(getScore(list.get(k))*addsc,sc*addsc,(double) j+1,count);
									keyword=(String)list.get(k);
								}
							}
						}
					}
					for(int k = 0; k < list2.size(); k++){
						if(AppFrame.option_recogType()==3){
							if(list2.size()>k){
								double addsc = 0.0;		//adds2;
								if(!ParseConfig.getUseSemFeat()){
									addsc =1.0;
								}
								if(ParseConfig.getUseSemFeat()){
									if(repetition(getSemantic((String)list2.get(k),0),voca2)){
										addsc = adds3;
									}
									if(getSemantic((String)list2.get(k),0).equals(sem2)){
										addsc = adds2;
										//System.err.println("b:"+list2.get(k));
									}
									//System.err.println("b:"+list2.get(k));
									if(getSemantic((String)list2.get(k),0).equals("unknown")){
										addsc = 0.2;
									}
								}
								if(!searchAnarhora((String)list2.get(k)) && !indispensa((String)list2.get(k))){
									if(repetition(getCase((String)list2.get(k),0),voca)){
										if(!repetition(list2.get(k),list)){
											if(calculation(0.0,getScore(list2.get(k))*addsc,(double)(j+1),count)>max){
												max=calculation(0.0,getScore(list2.get(k))*addsc,(double) j+1,count);
												keyword=(String)list2.get(k);
											}
										}
									}
								}
							}
						}
					}
				}

				//臒lȏłȂƏƉʂo͂Ȃ
				if(i == 0){
					if(max >= 0.04){
						keyword = key(keyword) + "(" + max + ")";
					}
					else{
						keyword = "";
					}
				}
				else{
					if(max >= 0.1){
						keyword = key(keyword) + "(" + max + ")";
					}
					else{
						keyword = "";
					}
				}
				text = text + "Ɖ͂ꂽP[" + keyword + "]";

				max = -1.0;
				keyword = "";
				line = text;
				Confidence.set(size,text);
			}

			FileWriter out = new FileWriter(new File("DL2.txt"));
			for(int i = 0; i != Confidence.size(); i++){
				text=(String)Confidence.get(i);
				out.write(text+"\n");
			}
			out.close();
		}catch(IOException e){
			System.err.println("error:"+e);
		}

		return line;
	}

	//ƉꂢɐXRA0.7t^
	public static String key(String line) {
		line = line.replaceFirst("\\(","\\{");
		line = line.replaceFirst("\\)","\\}");
		StringBuffer text= new StringBuffer(del(line.replaceAll("Ɖ͂ꂽP","").replaceAll(" ","")));

		if(text.indexOf("(")>=0){
			text = text.delete(text.lastIndexOf("("), text.lastIndexOf(")")+1);
		}
		if(text.indexOf("<")>=0){
			text = text.delete(text.indexOf("<"), text.indexOf(">")+1);
		}
		if(text.length()==0){
			return "";
		}
		line = text.toString().replaceAll("\\{","\\(");
		line = line.replaceAll("\\}","\\)");

		return line.toString()+"<0.7>";
	}

	//Pꒊo
	public static String getVoca(String line) {
		StringBuffer text= new StringBuffer(line);
		if(text.indexOf("(")>=0){
			text = text.delete(text.indexOf("("), text.length());
		}
		else if(text.indexOf(":")>=0){
			text = text.delete(text.indexOf(":"), text.length());
		}
		if(text.length()==0){
			return "";
		}
		else{
			return text.toString();
		}
	}

	//lineɊ܂܂Ă[]ׂď
	public static String del(String line) {
		String text= new String(line);
		text = text.replaceAll("\\[","");
		text = text.replaceAll("\\]","");
		return text;
	}

	//lineɊ܂܂XRAo
	public static double getScore(Object line) {
		String key = "<([0-9.]+)>";
		Pattern pat = Pattern.compile(key);
		Matcher mat = pat.matcher((String)line);
		double score=0.0;
		if(mat.find()){
			if(mat.group(1)!="")
			 score = Double.parseDouble(mat.group(1));
		}
		return score;
	}

	//list̒ɓPstr邩̔
	public static boolean repetition(String str,ArrayList<String> list){
		for(int i=0;i<list.size();i++){
			if(AnaphoraResolution.getVoca(list.get(i)).equals(str)){
				return true;
			}
		}
		return false;
	}
}