package ogss;


import java.io.File;
import java.util.ArrayList;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

public class ParseVoca {
	static ArrayList<String> vocaObj = new ArrayList<String>();
	static ArrayList<String> vocaLoc = new ArrayList<String>();
//	2011/1/12 ǉ@io͂ł悤Ɂ@sem̊iԂ֐
	public static String getFrame(String sem){
		vocaObj =tree("obj",vocaObj);
		vocaObj.add("obj");
		vocaLoc =tree("loc",vocaLoc);
		vocaLoc.add("loc");
		if(AnaphoraResolution.repetition(sem,vocaObj))	return "obj";
		else if(AnaphoraResolution.repetition(sem,vocaLoc))	return "loc";
		else if(sem.equals("person"))	return "agt";
		else	return "unknown";
	}

	public static boolean contains(String sen){

		try {
			// hLgr_[t@Ng𐶐
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
			// hLgr_[𐶐
			DocumentBuilder builder = dbfactory.newDocumentBuilder();
			// p[XsDocumentIuWFNg擾
			Document doc = builder.parse(new File("voca.xml"));
			// [gvf擾i^OFvocaj
			Element root = doc.getDocumentElement();

			// semanticvf̃Xg擾
			NodeList semanticList = root.getElementsByTagName("semantic");
			NodeList itemList = null;
			//String tmp = "";
			for (int i=0; i < semanticList.getLength() ; i++) {
				// semanticvf擾
				Element semanticElement = (Element)semanticList.item(i);

				// casevf̃Xg擾
				itemList = semanticElement.getElementsByTagName("item");

				for (int j=0; j < itemList.getLength() ; j++) {
					// casevf擾
					Element itemElement = (Element)itemList.item(j);

					// itemvf̍ŏ̎qm[hieLXgm[hj̒l擾
					String item = itemElement.getFirstChild().getNodeValue();

					if(sen.equals(item))
						return true;
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		return false;
	}

	//͕inputɂinput_s(Voca.xml_semantic)vfitemԂ
	public static String searching(String input_s,String input){
		try {
			// hLgr_[t@Ng𐶐
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
			// hLgr_[𐶐
			DocumentBuilder builder = dbfactory.newDocumentBuilder();
			// p[XsDocumentIuWFNg擾
			Document doc = builder.parse(new File("voca.xml"));
			// [gvf擾i^OFvocaj
			Element root = doc.getDocumentElement();
			//System.out.println("[gvf̃^OF" + root.getTagName());

			// semanticvf̃Xg擾
			NodeList semanticList = root.getElementsByTagName("semantic");
			NodeList itemList = null;
			ArrayList<String> childList = new ArrayList<String>();
			String tmp = "";
			tree(input_s,childList);

			// semanticvf̐[v
			for (int i=0; i < semanticList.getLength() ; i++) {
				// semanticvf擾
				Element semanticElement = (Element)semanticList.item(i);
				// semantice̒l擾
				String semantic = semanticElement.getAttribute("semantic");

				if(childList.contains(semantic)){
					// casevf̃Xg擾
					itemList = semanticElement.getElementsByTagName("item");
					for (int j=0; j < itemList.getLength() ; j++) {
						// casevf擾
						Element itemElement = (Element)itemList.item(j);
						// itemvf̍ŏ̎qm[hieLXgm[hj̒l擾
						String item = itemElement.getFirstChild().getNodeValue();
						if(input.indexOf(item)!=-1){
							if(item.length()>tmp.length()){
							return item;
							}
						}
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

//	͒PꃊXgwordlistɂinput_s(Voca.xml_semantic)vfitemԂ
	public static String searching(String input_s,String[] wordlist){
		try {
			// hLgr_[t@Ng𐶐
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
			// hLgr_[𐶐
			DocumentBuilder builder = dbfactory.newDocumentBuilder();
			// p[XsDocumentIuWFNg擾
			Document doc = builder.parse(new File("voca.xml"));
			// [gvf擾i^OFvocaj
			Element root = doc.getDocumentElement();
			//System.out.println("[gvf̃^OF" + root.getTagName());

			// semanticvf̃Xg擾
			NodeList semanticList = root.getElementsByTagName("semantic");
			NodeList itemList = null;
			ArrayList<String> childList = new ArrayList<String>();
			//String tmp = "";
			tree(input_s,childList);

			// semanticvf̐[v
			for (int i=0; i < semanticList.getLength() ; i++) {
				// semanticvf擾
				Element semanticElement = (Element)semanticList.item(i);
				// semantice̒l擾
				String semantic = semanticElement.getAttribute("semantic");

				if(childList.contains(semantic)){
					// casevf̃Xg擾
					itemList = semanticElement.getElementsByTagName("item");
					for (int j=0; j < itemList.getLength() ; j++) {
						// casevf擾
						Element itemElement = (Element)itemList.item(j);
						// itemvf̍ŏ̎qm[hieLXgm[hj̒l擾
						String item = itemElement.getFirstChild().getNodeValue();
						for(int k=0;k<wordlist.length;k++){
							if(item.equals(wordlist[k])){
								return item;
							}
						}
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
	//tree.xml̐eq֌WTinput_s̎qchildListɑ֐
	public static ArrayList<String> tree(String input_s,ArrayList<String> childList){
		try {
			// hLgr_[t@Ng𐶐
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
			// hLgr_[𐶐
			DocumentBuilder builder = dbfactory.newDocumentBuilder();
			// p[XsDocumentIuWFNg擾
			Document doc = builder.parse(new File("tree.xml"));
			// [gvf擾i^OFvocaj
			Element root = doc.getDocumentElement();
			//System.out.println("[gvf̃^OF" + root.getTagName());
			//doc.close();

			// semanticvf̃Xg擾
			NodeList treeList = root.getElementsByTagName("th");

			String now = input_s;
			// semanticvf̐[v
			for (int i=0; i < treeList.getLength() ; i++) {
				// semanticvf擾
				Element treeElement = (Element)treeList.item(i);
				// semantice̒l擾
				String parent = treeElement.getAttribute("par");
				String child = treeElement.getAttribute("chi");
				if(now.equals(parent)){

					if(child.equals("null")){
						if(!childList.contains(parent))
							childList.add(parent);
					}
					else{
						childList.add(child);
						tree(child,childList);
					}
				}

			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return childList;
	}

	//͕senɊ܂܂item̃XgԂ
	public static ArrayList<String> containsVoca(String sen){
		String wordList[] = sen.split(" ");
		ArrayList<String> inputList = new ArrayList<String>();
		//StringBuffer line = new StringBuffer();
		try {
			// hLgr_[t@Ng𐶐
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
			// hLgr_[𐶐
			DocumentBuilder builder = dbfactory.newDocumentBuilder();
			// p[XsDocumentIuWFNg擾
			Document doc = builder.parse(new File("voca.xml"));
			// [gvf擾i^OFvocaj
			Element root = doc.getDocumentElement();
			//System.out.println("[gvf̃^OF" + root.getTagName());

			// semanticvf̃Xg擾
			NodeList semanticList = root.getElementsByTagName("semantic");
			NodeList itemList = null;
			//String tmp = "";
			for (int i=0; i < semanticList.getLength() ; i++) {
				// semanticvf擾
				Element semanticElement = (Element)semanticList.item(i);
				// semantice̒l擾
				String semantic = semanticElement.getAttribute("semantic");

				// casevf̃Xg擾
				itemList = semanticElement.getElementsByTagName("item");

				for (int j=0; j < itemList.getLength() ; j++) {
					// casevf擾
					Element itemElement = (Element)itemList.item(j);

					// itemvf̍ŏ̎qm[hieLXgm[hj̒l擾
					String item = itemElement.getFirstChild().getNodeValue();

					if(sen.indexOf(item)!=-1){
						if(!inputList.contains(item)){
							for(int k=0;k<wordList.length;k++){
								if(item.equals(wordList[k])){
									System.out.println("item"+item);
//									2011/1/12 C@io͂悤ɂ܂
									inputList.add(item+"("+semantic+")"+":"+getFrame(semantic)+"<1.0>");
								}
							//line.append("["+item+":"+semantic+"<1.0>]\r");
							}
						}
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}

		return inputList;
	}

	//͕senɊ܂܂item̂par̎qitem̃XgԂ
	public static ArrayList<String> containsVoca(String sen,String par){
		ArrayList<String> inputList = new ArrayList<String>();
		StringBuffer line = new StringBuffer();
		ArrayList<String> child = new ArrayList<String>();
		tree(par,child);
		try {
			// hLgr_[t@Ng𐶐
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
			// hLgr_[𐶐
			DocumentBuilder builder = dbfactory.newDocumentBuilder();
			// p[XsDocumentIuWFNg擾
			Document doc = builder.parse(new File("voca.xml"));
			// [gvf擾i^OFvocaj
			Element root = doc.getDocumentElement();
			//System.out.println("[gvf̃^OF" + root.getTagName());

			String tmp = "";
			// semanticvf̃Xg擾
			NodeList semanticList = root.getElementsByTagName("semantic");
			NodeList itemList = null;
			for (int i=0; i < semanticList.getLength() ; i++) {
				// semanticvf擾
				Element semanticElement = (Element)semanticList.item(i);
				// semantice̒l擾
				String semantic = semanticElement.getAttribute("semantic");

				if(child.contains(semantic)){
					// casevf̃Xg擾
					itemList = semanticElement.getElementsByTagName("item");

					for (int j=0; j < itemList.getLength() ; j++) {
						// casevf擾
						Element itemElement = (Element)itemList.item(j);

						// itemvf̍ŏ̎qm[hieLXgm[hj̒l擾
						String item = itemElement.getFirstChild().getNodeValue();

						if(sen.indexOf(item)!=-1){
							if(!inputList.contains(item)){
								if(item.length()>tmp.length()){
									//2011/1/12 C@io͂悤ɂ܂
									inputList.add(item+"("+semantic+")"+":"+getFrame(semantic)+"<1.0>");
									line.append("["+item+"("+semantic+")"+":"+getFrame(semantic)+"<1.0>]\r");

								}
							}
						}
					}
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return inputList;
	}

	//input_i܂܂semanticԂ
	public static String findSemantic(String input_i){
		try {
			// hLgr_[t@Ng𐶐
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();
			// hLgr_[𐶐
			DocumentBuilder builder = dbfactory.newDocumentBuilder();
			// p[XsDocumentIuWFNg擾
			Document doc = builder.parse(new File("voca.xml"));
			// [gvf擾i^OFvocaj
			Element root = doc.getDocumentElement();
			//System.out.println("[gvf̃^OF" + root.getTagName());

			// semanticvf̃Xg擾
			NodeList semanticList = root.getElementsByTagName("semantic");
			NodeList itemList = null;
			for (int i=0; i < semanticList.getLength() ; i++) {
				// semanticvf擾
				Element semanticElement = (Element)semanticList.item(i);
				// semantice̒l擾
				String semantic = semanticElement.getAttribute("semantic");

				// casevf̃Xg擾
				itemList = semanticElement.getElementsByTagName("item");

				for (int j=0; j < itemList.getLength() ; j++) {
					// casevf擾
					Element itemElement = (Element)itemList.item(j);

					// itemvf̍ŏ̎qm[hieLXgm[hj̒l擾
					String item = itemElement.getFirstChild().getNodeValue();

					if(input_i.equals(item)){
						return semantic;
					}
				}
			}

		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
}