//Dp_main.java

package ogss;

import ogss.ParseConfig;


import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import ogss.OutputResult;

public class Juli{
	static int ex_JULIUS = 0;
	static JuliSentence juli = new JuliSentence();

	static String confidence(double threshold, double editdis){
		double value;
		String s;
		value = ((threshold - editdis) / threshold) * 100;
		if(value < 0)
			value = 0;
		DecimalFormat formatter = new DecimalFormat("###.#");
		s = formatter.format(value) + "%";
		return s;
	}

	public  static void exec(){

		/***************************************/
		/*       ݒFK͔F̐          */
		/***************************************/
		int N;
		if(AppFrame.option_recogType()==1)
			N = 0;
		else
			N = ParseConfig.getDssrNum(); // N = 4

		/***************************************/
		/*    @      ϐ錾                 */
		/***************************************/

		// ʌ(vbO:Juliusŏó1Avb:Julianŏó-1)
		// zcdistinction[Juliaň][b]
		int[] distinction = new int[N];
		int distinction_mid = 0;
		// ϐ
		int i;

		/****************************************/
		/*      ݒF臒l@@@@@@      */
		/****************************************/
		// ftHg
		double thresholdWhole_ed = ParseConfig.getTHoldWord();  	// bPʂ̕ҏWthresholdWhole_edłΗvbƂ
		double thresholdPhrase_ed = ParseConfig.getTHoldPhrase();	// PPʂ̕ҏWthresholdPhrase_edłΗvbƂ

		// ftHg
		double thresholdWhole_mid_ed = ParseConfig.getTHoldWordMid();  	// bPʂ̕ҏWthresholdWhole_edłΗvbƂ
		double thresholdPhrase_mid_ed = ParseConfig.getTHoldPhraseMid();	// PPʂ̕ҏWthresholdPhrase_edłΗvbƂ

		/****************************************/
		/*   @@@@   C@@@@  @    */
		/****************************************/

		//////////////////////////////
		//		̃`FbN		//
		//////////////////////////////

		//ҏWۑpIuWFNg[Juliaň][b]
		DpFunction Editdis[] = new DpFunction[N];


		int mediumNUM = ParseConfig.getDssrNum();

		//ҏWۑpIuWFNg[Juliaň][b]
		DpFunction Editdis2 = new DpFunction();


		//////////////////////////////
		//	Julian̎syє	//
		//////////////////////////////

		try{
			if(juli.getJuliusError() != 1 )			// JuliusG[łȂ
				AppFrame.textarea3.append("Julius:" + (String)juli.getPhonemeJulius().get(0) + "\n"); //mFp
			else
				AppFrame.textarea3.append("Julius:failed\n");

			for(i = 0; i < N; i++){		// N:Juliaň,i:Julian_ïi
				// eF킪FsĂȂΑs
				if(juli.getJulianError(i) != 1){		// Julian_iG[łȂ

					// ҏW߂
					Editdis[i] = new DpFunction();
					Editdis[i].EditDist((String)juli.getPhonemeJulius().get(0), (String)juli.getPhonemeJulian(i).get(0));

					/*******	ҏWŔ		*******/
					if(Editdis[i].getWhole_ed() < thresholdWhole_ed){
						distinction[i] = -1;
					}else if(Editdis[i].getPhrase_ed() < thresholdPhrase_ed)
						distinction[i] = -1;
					else
						if(distinction[i] != -1)	// ␔ŔʂłĂꍇ͌␔̌ʂgp
							distinction[i] = 1;

					AppFrame.textarea3.append("Julian(" + i + "):" + (String)juli.getJulianSentence(i).get(0) + "\n");

					if(AppFrame.option_detail() != 1)//
						AppFrame.textarea3.append(" (b)F "+ Editdis[i].getWhole_ed() + " (P)F "+ Editdis[i].getPhrase_ed()
								+ "\nFMxF"+confidence(thresholdWhole_ed,Editdis[i].getWhole_ed())+ "\n");
				}else AppFrame.textarea3.append("Julian(" + i + "):failed\n");
			}

			if(AppFrame.option_recogType() == 3){
				// K͔F킪sĂȂΎs
				if(juli.getJulianError(mediumNUM) != 1){
					AppFrame.textarea3.append("Julian(MEDIUM):" + (String)juli.getPhonemeJulian(mediumNUM).get(0) + "\n");

					// ҏW߂
					Editdis2 = new DpFunction();
					Editdis2.EditDist((String)juli.getPhonemeJulius().get(0), (String)juli.getPhonemeJulian(mediumNUM).get(0));

					AppFrame.textarea3.append("mid_ed = "+Editdis2.getWhole_ed()+"\n");

					if(Editdis2.getWhole_ed() < thresholdWhole_mid_ed){
						distinction_mid = -1;
					}else if(Editdis2.getPhrase_ed() < thresholdPhrase_mid_ed)
						distinction_mid = -1;
					else
						if(distinction_mid != -1)	// ␔ŔʂłĂꍇ͌␔̌ʂgp
							distinction_mid = 1;
				}else AppFrame.textarea3.append("Julian(MEDIUM):failed\n");
			}


			//////////////////////////////
			//	F̑Iyяo	//
			//////////////////////////////

			//	ϐ錾
			double min;				// ebɑ΂Ŝ̕ҏW̍ŏl
			int selectedJulian;		// IꂽJulian̔ԍ

			// lݒ
			min = 50;
			selectedJulian = -1;

			for(i = 0; i < N; i++){	//NFJuliaň
				// eF킪sĂȂΑs
				if(juli.getJulianError(i) != 1){

					// eJulianɗvb邩ǂ
					if(distinction[i] == -1){

						// Ŝ̕ҏW̍ŏl𓾂JulianI
						if(min > Editdis[i].whole_ed){
							min = Editdis[i].whole_ed;
							selectedJulian = i;
						}
					}
				}
			}

			if(selectedJulian == -1){
				// vbOƔfAJuliušʂo
				AppFrame.textarea3.append(" Julius : " + juli.getJuliusSentence().get(0) + "\n\n");

				// 2010/8/27ǉ@ŏIʂXML`ŕ\{DL2.txtlogc
				OutputResult outRes = new OutputResult();

				// L[[ho
				KeyExt extractedKeyword = new KeyExt((String)juli.getJuliusSentence().get(0),(String)juli.Juliusscore.get(0));
				outRes.output((String)juli.getJuliusSentence().get(0),0,AnaphoraResolution.zeroDitect(extractedKeyword.output),0);
				AppFrame.textarea4.append("-----------------------\n Julius : " + extractedKeyword.output + "\n");
				try{
					FileWriter filewriter = new FileWriter(new File("DL2.txt"),true);
					filewriter.write(extractedKeyword.output);
					filewriter.close();

				}catch(IOException e){
					e.printStackTrace();
				}
			}
			else{
				// vbƔfAIꂽJuliaňʂo
				AppFrame.textarea3.append(" Julian" + selectedJulian + ": "+ juli.getJulianSentence(selectedJulian).get(0) + "\n\n"); // 2011/0901/kk

				// 2010/8/27ǉ ŏIʂXML`ŕ\{DL2.txtlogc
				OutputResult outRes = new OutputResult();
				// ͂ďƉ
				AnaphoraResolution anaResolution = new AnaphoraResolution((String)juli.getJulianSentence(selectedJulian).get(0)); // 2011/0901/kk

				// 2011/1/20C i͂ɎsꍇL[[hoɐ؂ւ悤ύX
				if(anaResolution.line.equals("")){
					KeyExt extractedKeyword = new KeyExt((String)juli.getJuliusSentence().get(0),(String)juli.Juliusscore.get(0));
					outRes.output((String)juli.getJuliusSentence().get(0), 0, AnaphoraResolution.zeroDitect(extractedKeyword.output), 0);
					AppFrame.textarea4.append("-----------------------\n Julius : " + extractedKeyword.output + "\n");
					try{
						FileWriter filewriter = new FileWriter(new File("DL2.txt"), true);
						filewriter.write(extractedKeyword.output);
						filewriter.close();

					}catch(IOException e){
						e.printStackTrace();
					}
				}else {
					outRes.output((String)juli.getJulianSentence(selectedJulian).get(0),Editdis[selectedJulian].getWhole_ed(), AnaphoraResolution.zeroDitect(anaResolution.line), selectedJulian);
					AppFrame.textarea4.append("-----------------------\n Julian" + selectedJulian + ": " + anaResolution.line + "\n\n");
				}
				
				// kato added
				java.io.StringWriter wr = new java.io.StringWriter();
				outRes.output((String)juli.getJulianSentence(selectedJulian).get(0),
						Editdis[selectedJulian].getWhole_ed(), AnaphoraResolution.zeroDitect(anaResolution.line), selectedJulian, wr);
				wr.flush();
				jp.ac.kyutech.SRP.OGSSImpl.enqueueRecognitionResult(wr.getBuffer().toString());
				// end
			}

			// ێĂFʂ̃NA
			if(AppFrame.option_recogType() != 3)	juli.juli_clear();
			if(AppFrame.option_recogType() == 3){
				// lݒ
				boolean selectedMedium = false;
				// K͔F킪sĂȂm߂
				if(juli.getJulianError(mediumNUM) != 1){
					// eJulianɗvb邩ǂ
					if(distinction_mid == -1){
						selectedMedium = true;
					}
				}

				if(!selectedMedium){
					// vbOƔfAJuliušʂo
					if(juli.getJulianError(mediumNUM) != 1)
						AppFrame.textarea3.append(" Juliusmid : " + juli.getJulianSentence(mediumNUM).get(0)+"\n\n");
					else
						AppFrame.textarea3.append(" Juliusmid : failed\n\n");
					AppFrame.textarea4.append(" JuliusMid : \n--------------------\n");

					try{
						FileWriter filewriter = new FileWriter(new File("DL1.txt"),true);
						filewriter.write("\n");
						filewriter.close();
					}catch(IOException e){
						e.printStackTrace();
					}
				}else{
					String Line = new String();
					AppFrame.textarea3.append(" Juliusmid : " + juli.getJulianSentence(mediumNUM).get(0) + "\n\n");
					Line = juli.getJulianSentence(mediumNUM).get(0);

					Line = Line.replaceAll("<s>","");
					Line = Line.replaceAll("</s>","");

					KeyExt extractedKeyword = new KeyExt(Line,juli.getCmscoreSentence(mediumNUM).get(0));
					AppFrame.textarea4.append(" JuliusMid : " + extractedKeyword.output + "\n--------------------\n");

					try{
						FileWriter filewriter = new FileWriter(new File("DL1.txt"),true);
						filewriter.write(extractedKeyword.output);
						filewriter.close();
					}catch(IOException e){
						e.printStackTrace();
					}
				}
				// ێĂFʂ̃NA
				juli.juli_clear();
			}

		}catch (Exception e) {
			e.printStackTrace();
			if(AppFrame.option_recogType() != 3) juli.juli_clear();
		}
	}
}
