//Juli_sentence.java

package ogss;

import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.IOException;

// AllayLisť^z̃CX^X쐬̌x\ȂD
@SuppressWarnings("unchecked")

// bL^NX
public class JuliSentence{
	/***************************/
	/*         ϐ錾                   */
	/***************************/

	private static final String Error1 = "<search failed>";
	private static final String Error2 = "short input";
	private static final String Error3 = "phseq1: silB | sp | silE";

	public static int N = ParseConfig.getDssrNum() + 1; // b[ParseConfig.getDssrNum()]4 + b1
	ArrayList<String> JuliusSentence;		// Julius̏o͌()
	ArrayList<String> PhonemeJulius;		// Julius̏o͌(f\L)
	ArrayList<String> Juliusscore;			// Julius̃L[[hscore
	ArrayList<String> ResultJulius;			// Julius̃L[[ho

	ArrayList<String>[] JulianSentence;		// 2pX̌(Julian̏o͌)
	ArrayList<String>[] Pass1_sentence;		// 1pX̌
	ArrayList<String>[] PhonemeJulian;		// 2pX̌(f\L)//
	ArrayList<String>[] CmscoreSentence;	// Mx܂ވꕶ
	ArrayList<String>[] ResultJulian;		// Julian̈Ӗt[ϊ

	int JuliusError;					// julius̔Fsp̃tO
	int[] JulianError = new int[N];		// julian̔Fsp̃tO
	int[] N_best_count = new int[N];	// 2pX̌␔

	static int flg;						// Fԍ
	private static ArrayList<String> Recognizer_marker;	//}[J[쐬(:[#(0-9)+ Recognizer_Name])

	/***************************/
	/*      RXgN^                    */
	/***************************/

	JuliSentence() {
		//Fԍl邽߂̃}[J[쐬
		Recognizer_marker = new ArrayList<String>();
		try {
			BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(ParseConfig.getRecognizerConfPath())));
			String line ="";
			Pattern pt = Pattern.compile("-SR (.*?) (.+)");
			while((line = br.readLine())!= null){
				Matcher mt = pt.matcher(line);
				if(mt.matches())
					Recognizer_marker.add("[#"+(Recognizer_marker.size()+1)+" "+mt.group(1)+"]");
			}
			br.close();
		} catch(IOException e) {
			e.printStackTrace();
		}

		this.JuliusSentence = new ArrayList<String>();
		this.PhonemeJulius = new ArrayList<String>();
		this.ResultJulius = new ArrayList<String>();
		Juliusscore = new ArrayList<String>();

		this.JulianSentence = new ArrayList[N];
		this.Pass1_sentence = new ArrayList[N];
		this.PhonemeJulian = new ArrayList[N];
		this.CmscoreSentence = new ArrayList[N];
		this.ResultJulian = new ArrayList[N];

		for(int i = 0; i < N; i++){
			this.JulianSentence[i] = new ArrayList<String>();
			this.Pass1_sentence[i] = new ArrayList<String>();
			this.PhonemeJulian[i] = new ArrayList<String>();
			this.CmscoreSentence[i] = new ArrayList<String>();
			this.ResultJulian[i] = new ArrayList<String>();
		}

		this.juli_clear();
	}

	public void juli_clear(){

		JuliusSentence.clear();
		PhonemeJulius.clear();
		ResultJulius.clear();
		Juliusscore.clear();

		for(int i = 0; i < N; i++){
			JulianSentence[i].clear();
			Pass1_sentence[i].clear();
			PhonemeJulian[i].clear();
			CmscoreSentence[i].clear();
			ResultJulian[i].clear();
			N_best_count[i] = 0;
		}
		JuliusError = 0;
		for(int i = 0; i < N; i++)
			JulianError[i] = 0;

	}

	/***************************/
	/*     Getter̍쐬@ @@ */
	/***************************/

	public ArrayList<String> getJuliusSentence() {
		return JuliusSentence;
	}

	public ArrayList<String> getPhonemeJulius() {
		return PhonemeJulius;
	}

	public ArrayList<String> getCmscoreSentence(int i) {
		return CmscoreSentence[i];
	}

	public ArrayList<String> getJuliusscore() {
		return Juliusscore;
	}

	public ArrayList<String> getJulianSentence(int i) {
		return JulianSentence[i];
	}

	public ArrayList<String> getPhonemeJulian(int i) {
		return PhonemeJulian[i];
	}

	public int getJulianError(int i) {
		return JulianError[i];
	}

	public int getJuliusError() {
		return JuliusError;
	}

	public void sendtext(String line){
		if(line.startsWith("[#")){
			for(int i=0;i<Recognizer_marker.size();i++){
				if(line.equals(Recognizer_marker.get(i)))
					flg = i;
			}
		}

		// FsF킪邩ǂ̔
		if(line.startsWith(Error1)||line.startsWith(Error2)||line.startsWith(Error3)){
			if(flg == 0)
				JuliusError = 1;
			else
				JulianError[flg - 1] = 1;
		}

		/***	sentence1(o͌)Ŏn܂1ۑ		***/
			if (line.startsWith("sentence1:")){
				if((0 < flg) && (flg < (N + 1))){
					JulianSentence[flg-1].add(line);
				}else if(flg == 0)
					JuliusSentence.add(line);
				else
					AppFrame.textarea3.append("Juli_sentence_flgerror1" + "\n");
			}

		/***	phseq1(f\L)Ŏn܂1ۑ	***/
		if(line.startsWith("phseq1:")){
			if((0 < flg) && (flg < (N + 1)))
				PhonemeJulian[flg-1].add(ClearSentence.clear(line));
			else if(flg == 0)
				PhonemeJulius.add(ClearSentence.clear(line));
			else
				AppFrame.textarea3.append("Juli_sentence_flgerror2" + "\n");
		}

		/***	pass1_best(1pX̌)Ŏn܂1ۑ		***/
		if(line.startsWith("pass1_best:")){
			if((0 < flg) && (flg < (N + 1))){
				N_best_count[flg - 1] = 0;
				Pass1_sentence[flg - 1].add(line);
			}
		}

		/***	cmscore1(Mx)Ŏn܂1ۑ	***/
		if(line.startsWith("cmscore1:")){
			if((0 < flg) && (flg < (N + 1))){
				CmscoreSentence[flg - 1].add(line);
			}
			Juliusscore.add(line);
		}

		/***	N-besť␔𐔂		***/
		if(line.startsWith("sentence")){
			if((0 < flg) && (flg < (N + 1)))
				N_best_count[flg - 1]++;
		}
	}
}
