package ogss;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import ogss.ParseConfig;
/* juliusvZXs */

public class JuliusTask implements Runnable {
	/** julius̎sɊւϐQ **/
	static int FileNUM;
	static String FolderNAME = new String();
	static int num;
	static int folderNo=1;
	static Process process;
	static String cmd="";

	/** julius̉͊𔻒f邽(julis邽)̕ϐQ **/
	// juliusɏo͂镶
	private static final String InitialStr1 = "STAT: include config:";
	private static final String InitialStr2 = "STAT: All init successfully done";
	// julius̉͑Oɏo͂镶
	private static final String AnalysisStr1 = "------";
	private static final String AnalysisStr2 = "### read waveform input";
	// julius̉͏Ă邩tO
	private static boolean AnalysisFlg = false;
	// 2AjulisȂ߂̃tO
	private static boolean BreakFlg = false;
	// short inputjulisȂ悤ɂ邽߂̕ƃtO
	private static final String JuliusResultStr = "[#1 julius]";
	private static final String RejectStr = "<input rejected by short input>";
	private static boolean JuliusResultFlg = false;
	private static boolean RejectFlg = false;

	public void run() {
	ExecutorService executorService = Executors.newFixedThreadPool(2);
		try {
			AppFrame.run("       julius  run.... ");
			process = null;
			//WI{^̃`FbN
			int option = AppFrame.option();
			/** ꂼ̃IvVjulius-4.0.2s **/
			//}CN͂̏ꍇ
			if(option==1) cmd = ParseConfig.getJuliusPath()+" -C "+ParseConfig.getRecognizerConfPath()+" "+ParseConfig.getOpInputMic()+" "+ParseConfig.getOpCNet();
			//Pt@C͂̏ꍇ
			else if(option==2) cmd = ParseConfig.getJuliusPath()+" -C "+ParseConfig.getRecognizerConfPath()+" "+ParseConfig.getOpInputFile()+" "+ParseConfig.getOpCNet();
			//t@C͂̏ꍇ
			else if(option==3) cmd =ParseConfig.getJuliusPath()+" -C "+ParseConfig.getRecognizerConfPath()+" "+ParseConfig.getOpInputFList()+ ParseConfig.getFListName() + FileNUM + ".jconf" +" "+ParseConfig.getOpCNet();

			//ƗvZXŃR}hs
	    	process = Runtime.getRuntime().exec(cmd);

	    	//vOIɎs鏈
		    Runtime.getRuntime().addShutdownHook(new Shutdown());
		    executorService.submit(new StdErrorConsumer(process.getErrorStream()));

		    int flg_confnet = 0, flg_n_best = 0;

		    //o͌ʂ\
	    	InputStream is = process.getInputStream();
	    	BufferedReader br = new BufferedReader(new InputStreamReader(is));
	    	String line;
	    	String current_recognizer = "this_is_initial_string";

	    	while ((line = br.readLine()) != null) {
	    		System.out.println(line);
	    		AppFrame.sendtextarea(line);

	    		if(line.startsWith("[#")) current_recognizer = line;

	    		//N-besťʂbegin
	    		/**** N-best ****/
	    		if(line.equals((flg_n_best == 0) && line.startsWith("sentence1:"))){
	    		    fileInit("N_best.txt");	    	//t@CN_best.txt
	    		    fileInit("Confnet.txt");		//t@CConfnet.txt
	    		    flg_n_best = 1;
	    		}

	    		//N-besťʂeLXg֏
	    		if(line.startsWith("sentence1:"))
	    			fileAddData("N_best.txt",current_recognizer);
	    		if(line.startsWith("sentence")||line.startsWith("wseq")||line.startsWith("phseq")||line.startsWith("score"))
	    			fileAddData("N_best.txt",line);

			    //N-besťʂend

	    		//confusion networko͂begin
	    		if(line.equals("---- begin confusion network ---")){
	    			fileAddData("Confnet.txt",current_recognizer);
	    			flg_confnet = 1;
	    		}
	    		/**** confusion network ****/

	    		//confusion networǩʂeLXgo
	    		if(flg_confnet == 1) {
	    			//Confusion Networkt@C֏
	    			fileAddData("Confnet.txt",line);
	    		}
	    		//confusion networko͂end
	    		if(line.equals("---- end confusion network ---"))
	    			flg_confnet = 0;


	    		// juliusSentencẻ͌ʂXV邽ߏo͂𑗂

	    		Juli.juli.sendtext(line);

	    		/**** bԂ̏I̔ʂjuli̎s ****/
	    		// ̃tO
	    		if(line.startsWith(InitialStr1) || line.equals(InitialStr2)) AnalysisFlg = false;
	    		// ̃tO
	    		if(line.equals(AnalysisStr1) || line.equals(AnalysisStr2)) AnalysisFlg = true;
	    		// [#1 julius]͌ʂ̏o͊JñtO
	    		if(line.equals(JuliusResultStr)) JuliusResultFlg = true;
	    		// [#1 julius]FsƂ̃tO
	    		if(JuliusResultFlg && line.equals(RejectStr)) RejectFlg = true;
	    		// [#1 julius]̉͌ʂ̏o͊Jn(ɊJnꂽ)̃tO
	    		if(JuliusResultFlg && !line.equals(JuliusResultStr)) JuliusResultFlg = false;

	    		// 󔒍so & ͒tOE󔒍sAtOE͎stOK -> b̉͊ƔfDjulis
	    		if(line.equals("")){
	    			current_recognizer = "this_is_initial_string";
	    			flg_n_best = 0;
	    			if(AnalysisFlg && !BreakFlg && !RejectFlg){
	    				BreakFlg = true;
	    				Juli.exec();
	    			}
	    			RejectFlg = false;
	    		}
	    		if(BreakFlg && !line.equals(""))
	    			BreakFlg = false;
	    	}
	    	br.close();
	    	is.close();
		}catch (IOException e) {
	    	e.printStackTrace();
		}
		finally {
			executorService.shutdown();
		}
	}

	// ̃t@C
	private static void fileInit(String fname){
	    try {
	    	BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(fname)));
			bw.close();
	    } catch(IOException e) {
	    	e.printStackTrace();
	    }
	}

	// fileNamẽt@CɈline݁̕CsD
	private static void fileAddData(String fname,String line){
	    try {
	    	BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(fname, true)));
	    	bw.write(line); //V̏
	    	bw.newLine();   //s
	    	bw.close();
	    } catch(IOException e) {
	    	e.printStackTrace();
	    }
	}

	//ꂽt@CpXR}hs
	public static void file(String filename){
		cmd = filename ;
		try {
			System.out.println(cmd);
			OutputStream os = process.getOutputStream();
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(os));
			bw.write(cmd);
			process = Runtime.getRuntime().exec("cmd /C exit");
			//o͌ʂ\
			InputStream is = process.getInputStream();
			BufferedReader br = new BufferedReader(new InputStreamReader(is));
			String line;
			while ((line = br.readLine()) != null) {
				System.out.println(line);
				AppFrame.sendtextarea(line);
			}
			bw.close();
			os.close();
	    	is.close();
	    	br.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	//vZXI
	public static void stop(){
		if(process != null)
			process.destroy();
	}

	class StdErrorConsumer implements Runnable {
		protected InputStream error;
		public StdErrorConsumer(InputStream error) {
			this.error = error;
		}
    //@Override
		public void run() {
			char[] buf = new char[1024];
			int numOfRead = 0;
			BufferedReader reader = new BufferedReader(new InputStreamReader(error));
			Writer writer = new OutputStreamWriter(System.err);
			try {
				while ((numOfRead = reader.read(buf)) > 0) {
					writer.write(buf, 0, numOfRead);
					writer.flush();
				}
			} catch (Exception e) {
			} finally {
				try {
					error.close();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
	}
}
